/***************************************************************************
	FILE:				capow.cpp
	PROJECT:			CAMCOS CAPOW!
	ENVIRONMENT:	Borland C++ 4.0/MS Windows 3.1


	UPDATE LOG:

	4-18-94 (CBM)	changed about dlg procedure use in WinProc to allow
				a bitmap to appear on the dialog box.

	5-16-94 (RR) Let's start really using this log.  Today I built
	the alpha3 version.  This uses the large model instead of medium
	model so we can have 49 CAs.  This version seems unreliable when
	the NOUNLOCK flag is commented out.

	5-17-94 (RR) Elimated all the lock/unlock GlocablAlloc, etc.
	stuff entirely, went to new and delete alone.  Got rid of the
	FUNCTIONPOINTER switch, revised CAlist::Evolve. Fixed a bad
	bug (oldstates not initialized). Caption Alpha 3.

	5-17-94 (AB) Fixed Wave file loading. Put an exit button on the cycle
	box. Reversed the menu order of Controls. Change Settable to SetCA.

	5-19-94 (RR) Changed caption to Alhpa 4. Changed the alternate
	cursors to be more suggestive of what they do, also changed their
	labels.  Upped the max CA count to 64.

	5-19-94 (RR) Removed Timer and Lookup from Tools.  Tweaked the cursor
	menu names, tweaked the names of CAs, Breeding, World.  Moved
	Randomize() to WM_CREATE so that startups are always different.
	Alpha 5.  Ready to Print out source.  This version is the one we
	document and send EPRI in June?

	5-23-94 (RR) Put in the Reverse button on the World menu to
	reverse a reversible CA.  Fixed it so that when TYPE_CA_REVERSIBLE,
	the AvoidStripes will not call Seed at a stripe failure.
	Changed caption to Alpha 6. Made CAlist::Evolve simply reset scores
	and return if zoomflag is on.

	10-8-94 Add 'Experiment' menu item 'Controls' to display
	horizontal and vertical parameters and ranges.

	11-7-94 RR change the updatewave rule and the generator::step.  Beta4.

	2-26-95 RR put in diverse oscillator, fix avoidstripes to work
	with wave methods.  Beta 11.

	3-10-95 JL put in graph display, changed by RR.  RR changed water wave.
	
****************************************************************************/
// These first two headers are needed for Randomize()
#include <stdlib.h>
#include <time.h>

#include <windows.h>
#include <string.h>
#include "ca.hpp"
#include "bitmap.hpp"
#include "random.h"
#include "camenu.h"
#include "commdlg.hpp"


//--------Global Variables----
HANDLE hInst;
HWND hwnd;	// The master window
HWND hDlgParams = 0, hDlgLookup = 0, hDlgZap = 0,
	hDlgCycle = 0, hDlgExp = 0;
FARPROC lpitProcLookup, lpitProcParams, lpitProcZap,
	lpitProcCycle, lpitProcExp;
unsigned char update_flag = 0; /* Something has changed, updates
	params, cycle, lookup dialog boxes */
short cursormode = CUR_PICK;	// Current cursor mode
// JY === 10/17
short dim = 1;
// JY --- 10/17
//---------Global Data------
int nDrawMode = R2_COPYPEN;
CAlist *calife_list;
WindowBitmap *WBM;

//--------Global Functions----
void Cellmain(HWND); //This is the continually running thing.
long FAR PASCAL WndProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL ParamsProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL ZapProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL CycleProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL AboutProc(HWND, UINT, UINT, LONG);
extern BOOL FAR PASCAL ExpProc(HWND, UINT, UINT, LONG);

char szAppName[] = "CAPow";

//---------Windows Overhead------------
int PASCAL WinMain (HANDLE hInstance, HANDLE hPrevInstance,
	LPSTR lpszCmdParam, int nCmdShow)
{
	MSG msg;
	WNDCLASS wndclass;

	if (!hPrevInstance)
	{
		wndclass.style = CS_HREDRAW | CS_VREDRAW;
		wndclass.lpfnWndProc = WndProc;
		wndclass.cbClsExtra = 0;
		wndclass.cbWndExtra = 0;
		wndclass.hInstance = hInstance;
		wndclass.hIcon = LoadIcon( hInstance, szAppName );
		wndclass.hCursor = LoadCursor( NULL, IDC_ARROW );
		wndclass.hbrBackground = GetStockObject( BLACK_BRUSH );
		wndclass.lpszMenuName = szAppName;
		wndclass.lpszClassName = szAppName;

		RegisterClass (&wndclass);
	}

	hInst = hInstance;

	hwnd = CreateWindow(szAppName,		// window class name
			"CAPOW! (Ver 1.0) Cellular Automata for Power Grid Simulation",	// window caption
			WS_OVERLAPPEDWINDOW,		// window style
			CW_USEDEFAULT,				// initial x position
			CW_USEDEFAULT,				// initial y position
			380,				// initial x size
			400,				// initial y size
			NULL,					// parent window handle
			NULL,					// window menu handle
			hInstance,				// program instance handle
			NULL);					// creation parameters


	ShowWindow(hwnd, nCmdShow);
	UpdateWindow(hwnd);

	while (TRUE) //Keep it growing.  See Petzold's RANDRECT example.
	{
		if ( PeekMessage( &msg, NULL, 0, 0, PM_REMOVE ) )
		{
			if (hDlgParams ||  hDlgZap || hDlgCycle ||
				 hDlgExp)
			{
				if (!(IsDialogMessage(hDlgParams, &msg) ||
						IsDialogMessage(hDlgZap, &msg) ||
					IsDialogMessage(hDlgCycle, &msg) ||
					IsDialogMessage(hDlgExp, &msg)))
					{
						if (msg.message == WM_QUIT)
							break;
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
			}
			else
			{
				if (msg.message == WM_QUIT)
					break;
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}
		else
			Cellmain(hwnd);
	}
	return msg.wParam;

}
//-------------------Message Processing--------
long FAR PASCAL WndProc( HWND hwnd, unsigned int message,
	unsigned int wParam, LONG lParam)
{
	HDC hdc;
//	HMENU hMenu;
	RECT rect;

//Begin commdlg stuff
	#define MAXFILENAME 256
	/* maximum length of file with pathname      */
	OPENFILENAME ofn;
	char szFilterSpecCA [128] =
		"CA Files (*.CA)\0All Files (*.*)\0*.*\0";
	char szFilterSpecCAS [128] =
		"Experiment Files (*.CAS)\0All Files (*.*)\0*.*\0";
		/* file type filters */
	char szFileName[MAXFILENAME];
	char szFileTitle[MAXFILENAME];
	static FARPROC	lpfnAbout; // for about box

//End commdlg stuff

	switch (message)
	{
		case WM_CREATE :
/* Normally call Randomize here so that the CAs you are about to
	new will have unique lookup tables.  Turn this off for DEBUG
	mode to make it easier to reproduce problems.*/
#ifndef DEBUG
			Randomize();
#endif  //DEBUG
			WBM = new WindowBitmap(hwnd);
			calife_list = new CAlist(hwnd, MAX_CAS); //Calls CA:Allocate for members
			calife_list->SetWindowBitmap(WBM); //Registers

		/* Initialize dialog boxes*/
			lpitProcParams = MakeProcInstance( (FARPROC) ParamsProc, hInst);
			lpitProcZap = MakeProcInstance( (FARPROC) ZapProc, hInst);
			lpitProcCycle = MakeProcInstance( (FARPROC) CycleProc, hInst);
			lpitProcExp = MakeProcInstance( (FARPROC) ExpProc, hInst);
			lpfnAbout = MakeProcInstance((FARPROC) AboutProc, hInst);
			return 0;

		case WM_PAINT:
			update_flag = 1;
			WBM->Repaint(hwnd);
			return 0;

		case WM_SIZE:
		/* If the window is minimized, put the CA's to sleep */
			if (wParam == SIZE_MINIMIZED)
			{
				calife_list->SetSleep(1);
				return 0;
			}
		/* wake them up if restored */
			if (wParam == SIZE_RESTORED || wParam == SIZE_MAXIMIZED)
				calife_list->SetSleep(0);
			GetClientRect(hwnd, &rect);
			calife_list->Locate(rect.right,rect.bottom);

			SendMessage(hwnd, WM_COMMAND, IDM_CLEAR, 0L);
/* The IDM_CLEAR erases the bitmap and the screen and draws the
focus box on both of them.*/
			return 0;

		case WM_COMMAND:
/*Be sure to exit each case of this switch with a break in case we
ever want to do something special at the end*/
			switch(wParam)
			{
				case IDM_OPEN_INDIVIDUAL:
					strcpy(szFileName,"*.CA");
				// fill in non-variant fields of OPENFILENAME struct.
					ofn.lStructSize       = sizeof(OPENFILENAME);
					ofn.hwndOwner	  = hwnd;
					ofn.lpstrFilter	  = szFilterSpecCA;
					ofn.lpstrCustomFilter = NULL;
					ofn.nMaxCustFilter	  = 0;
					ofn.nFilterIndex	  = 1;
					ofn.lpstrFile         = szFileName;
					ofn.nMaxFile	  = MAXFILENAME;
					ofn.lpstrInitialDir   = NULL;
					ofn.lpstrFileTitle    = szFileTitle;
					ofn.nMaxFileTitle     = MAXFILENAME;
					ofn.lpstrTitle        = NULL;
					ofn.lpstrDefExt       = "CA";
					ofn.Flags             = 0;
					if( GetOpenFileName((LPOPENFILENAME)&ofn) )
						calife_list->Loadindividual(szFileName, calife_list->FocusCA());
					update_flag = 1;
						break;

				case IDM_SAVE_INDIVIDUAL:
					strcpy(szFileName,"*.CA");
			/* fill in non-variant fields of OPENFILENAME struct. */
					ofn.lStructSize       = sizeof(OPENFILENAME);
					ofn.hwndOwner	  = hwnd;
					ofn.lpstrFilter	  = szFilterSpecCA;
					ofn.lpstrCustomFilter = NULL;
					ofn.nMaxCustFilter	  = 0;
					ofn.nFilterIndex	  = 1;
					ofn.lpstrFile         = szFileName;
					ofn.nMaxFile	  = MAXFILENAME;
					ofn.lpstrInitialDir   = NULL;
					ofn.lpstrFileTitle    = szFileTitle;
					ofn.nMaxFileTitle     = MAXFILENAME;
					ofn.lpstrTitle        = NULL;
					ofn.lpstrDefExt       = "CA";
					ofn.Flags             = 0;
					if( GetSaveFileName((LPOPENFILENAME)&ofn) )
						calife_list->Saveindividual(szFileName,calife_list->FocusCA());
					break;

				case IDM_OPEN_ALL:
					strcpy(szFileName,"*.CAs");
				// fill in non-variant fields of OPENFILENAME struct.
					ofn.lStructSize       = sizeof(OPENFILENAME);
					ofn.hwndOwner	  = hwnd;
					ofn.lpstrFilter	  = szFilterSpecCAS;
					ofn.lpstrCustomFilter = NULL;
					ofn.nMaxCustFilter	  = 0;
					ofn.nFilterIndex	  = 1;
					ofn.lpstrFile         = szFileName;
					ofn.nMaxFile	  = MAXFILENAME;
					ofn.lpstrInitialDir   = NULL;
					ofn.lpstrFileTitle    = szFileTitle;
					ofn.nMaxFileTitle     = MAXFILENAME;
					ofn.lpstrTitle        = NULL;
					ofn.lpstrDefExt       = "CAS";
					ofn.Flags             = 0;
					if( GetOpenFileName((LPOPENFILENAME)&ofn) )
						calife_list->Loadall(szFileName);
					update_flag = 1;
						break;

				case IDM_SAVE_ALL:
					strcpy(szFileName,"*.CAs");
			/* fill in non-variant fields of OPENFILENAME struct. */
					ofn.lStructSize       = sizeof(OPENFILENAME);
					ofn.hwndOwner	  = hwnd;
					ofn.lpstrFilter	  = szFilterSpecCAS;
					ofn.lpstrCustomFilter = NULL;
					ofn.nMaxCustFilter	  = 0;
					ofn.nFilterIndex	  = 1;
					ofn.lpstrFile         = szFileName;
					ofn.nMaxFile	  = MAXFILENAME;
					ofn.lpstrInitialDir   = NULL;
					ofn.lpstrFileTitle    = szFileTitle;
					ofn.nMaxFileTitle     = MAXFILENAME;
					ofn.lpstrTitle        = NULL;
					ofn.lpstrDefExt       = "CAS";
					ofn.Flags             = 0;
					if( GetSaveFileName((LPOPENFILENAME)&ofn) )
						calife_list->Saveall(szFileName);
					break;

				case IDM_RANDOMIZE:
					calife_list->Randomize();
					SendMessage(hwnd, WM_COMMAND, IDM_CLEAR, 0L);
					break;

				case IDM_PAUSE:
					calife_list->ToggleSleep();
					CheckMenuItem(GetMenu(hwnd),IDM_PAUSE,MF_BYCOMMAND|
						((calife_list->GetSleep())?MF_CHECKED:MF_UNCHECKED));
					break;

				case IDM_EXIT:
					SendMessage(hwnd,WM_CLOSE,0,0L);
					break;

				case IDM_HELP:
					WinHelp(hwnd, "capow.hlp", HELP_INDEX, HELP_INDEX);
					break;

				case IDM_PARAMS:
					if (!hDlgParams)
					{
						hDlgParams = CreateDialog (
							hInst, (LPSTR)"PARAMS", hwnd, lpitProcParams);
						GetWindowRect(hDlgParams, &rect);
						rect.bottom-=rect.top;
						rect.right-=rect.left;
						rect.left = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"PARAMSX",100);
						rect.top = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"PARAMSY",100);
						if (GetSystemMetrics(SM_CXSCREEN)<rect.left-10)
							rect.left=25;
						if (GetSystemMetrics(SM_CYSCREEN)<rect.top-10)
							rect.top=25;
						MoveWindow(hDlgParams, rect.left,rect.top,rect.right,rect.bottom,FALSE);
						ShowWindow(hDlgParams, TRUE);
					}
					else
						DestroyWindow(hDlgParams);
					break;

				case IDM_ZAP:
					if (!hDlgZap)
					{
						hDlgZap = CreateDialog (
							hInst, (LPSTR)"ZAP", hwnd, lpitProcZap);
						GetWindowRect(hDlgZap, &rect);
						rect.bottom-=rect.top;
						rect.right-=rect.left;
						rect.left = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"ZAPX",100);
						rect.top = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"ZAPY",100);
						if (GetSystemMetrics(SM_CXSCREEN)<rect.left-10)
							rect.left=25;
						if (GetSystemMetrics(SM_CYSCREEN)<rect.top-10)
							rect.top=25;
						MoveWindow(hDlgZap, rect.left,rect.top,rect.right,rect.bottom,FALSE);
						ShowWindow(hDlgZap, TRUE);
					}
					else
						DestroyWindow(hDlgZap);
					break;

				case IDM_CYCLE:
					if (!hDlgCycle)
					{
						hDlgCycle = CreateDialog (
							hInst, (LPSTR)"CYCLE", hwnd, lpitProcCycle);
						GetWindowRect(hDlgCycle, &rect);
						rect.bottom-=rect.top;
						rect.right-=rect.left;
						rect.left = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"CYCLEX",100);
						rect.top = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"CYCLEY",100);
						if (GetSystemMetrics(SM_CXSCREEN)<rect.left-10)
							rect.left=25;
						if (GetSystemMetrics(SM_CYSCREEN)<rect.top-10)
							rect.top=25;
						MoveWindow(hDlgCycle, rect.left,rect.top,rect.right,rect.bottom,FALSE);
						ShowWindow(hDlgCycle, TRUE);
					}
					else
						DestroyWindow(hDlgCycle);
					break;



				case IDM_EXP:
					if (!hDlgExp)
					{
						hDlgExp = CreateDialog (
							hInst, (LPSTR)"EXPERIMENT", hwnd, lpitProcExp);
						GetWindowRect(hDlgExp, &rect);
						rect.bottom-=rect.top;
						rect.right-=rect.left;
						rect.left = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"EXPERIMENTX",100);
						rect.top = (int)GetProfileInt((LPSTR)szAppName,(LPSTR)"EXPERIMENTY",100);
						if (GetSystemMetrics(SM_CXSCREEN)<rect.left-10)
							rect.left=25;
						if (GetSystemMetrics(SM_CYSCREEN)<rect.top-10)
							rect.top=25;
						MoveWindow(hDlgExp, rect.left,rect.top,rect.right,rect.bottom,FALSE);
						ShowWindow(hDlgExp, TRUE);
					}
					else
						DestroyWindow(hDlgExp);
					break;

				case IDM_ABOUT:
					DialogBox(hInst, "ABOUT", hwnd, lpfnAbout);
					break;

				case IDM_CLEAR:
					WBM->Clear(hwnd, RGB(0,0,0));
					hdc = GetDC(hwnd);
					calife_list->Boxfocus(hdc,RGB(255,255,255));
					ReleaseDC(hwnd,hdc);
					calife_list->DrawDivider(hdc);
					break;

				case CUR_PICK:
				case CUR_ZAP:
				case CUR_COPY:
					CheckMenuItem( GetMenu(hwnd), wParam,
						MF_BYCOMMAND | MF_CHECKED);
					CheckMenuItem( GetMenu(hwnd), cursormode,
						MF_BYCOMMAND | MF_UNCHECKED);
					SetClassWord(hwnd, GCW_HCURSOR, LoadCursor(hInst,
						MAKEINTRESOURCE(wParam)));
					cursormode = wParam;
					break;
			}
			return 0;

		case WM_LBUTTONDOWN:
			hdc = GetDC(hwnd);
			switch(cursormode)
			{
/* If you are unzoomed and click on the focus, this zooms.
	If you are zoomed and click on the focus, this unzooms.
	If you are unzoomed and click on another, it changes the
		focus to the one you clicked on */
				case CUR_PICK:
					if (calife_list->Setfocus(hdc, calife_list->
						Getfocus(LOWORD (lParam),
						HIWORD (lParam))) == 1)
		/* if == 1 then the user is clicking on the focused ca, so zoom
			if == 0 then Setfocus has set the focus to the ca the user
			clicked on, so update the params dialog box... */
					{
                  calife_list->Zoom(1);
                  SendMessage(hwnd, WM_SIZE, 0, 0L);
					}
					else
						update_flag = 1;
					break;

/* This just copy mutates the focus to all other CA's.  If you click on
	a CA other that the focus, it changes focus to the one you clicked on
	and copy mutates that CA to all others. */
				case CUR_ZAP:
					calife_list->Setfocus(hdc, calife_list->Getfocus(LOWORD (lParam),
						HIWORD (lParam)));
					calife_list->Copymutate();
					SendMessage(hwnd, WM_COMMAND, IDM_CLEAR, 0L);
					break;


/* This copies the focused CA into the CA that you left click on.
	It makes an exact duplicate copy regardless of CA type.
	If you right click, it changes the focus */
				case CUR_COPY:
					calife_list->CopyCA(calife_list->FocusCA(),
						calife_list->Getfocus(LOWORD (lParam), HIWORD (lParam)));
					GetClientRect(hwnd, &rect);
					calife_list->Locate(rect.right,rect.bottom); // Make sure they're at the top
					SendMessage(hwnd, WM_COMMAND, IDM_CLEAR, 0L);
					break;

			}
			ReleaseDC(hwnd, hdc);
			return 0;

		case WM_RBUTTONDOWN:
			hdc = GetDC(hwnd);
			switch(cursormode)
			{
				case CUR_PICK:
					if (calife_list->Zoom(0))
						SendMessage(hwnd, WM_SIZE, 0, 0L);
					break;

/* This just changes the focus.  I thought it would be neat to copy with
	the left button and change focus with the right */
				case CUR_COPY:
					calife_list->Setfocus(hdc, calife_list->Getfocus(LOWORD (lParam),
						HIWORD (lParam)));
					update_flag = 1;
					break;
			}
			ReleaseDC(hwnd, hdc);
			return 0;

		case WM_CLOSE:
		case WM_DESTROY:
		// Close any boxes that may be open
			if (hDlgParams)
			{
				DestroyWindow( hDlgParams);
				hDlgParams = 0;
			}
			FreeProcInstance( (FARPROC)lpitProcParams );

			if (hDlgZap)
			{
				DestroyWindow( hDlgZap);
				hDlgZap = 0;
			}
			FreeProcInstance( (FARPROC)lpitProcZap );

			if (hDlgCycle)
			{
				DestroyWindow( hDlgCycle);
				hDlgCycle = 0;
			}
			FreeProcInstance( (FARPROC)lpitProcCycle );



			if (hDlgExp)
			{
				DestroyWindow( hDlgExp);
				hDlgExp = 0;
			}
			FreeProcInstance( (FARPROC)lpitProcExp );

			// Free bitmap
			delete WBM;
			PostQuitMessage (0) ;
			return 0 ;

	}
	return DefWindowProc (hwnd, message, wParam, lParam) ;
}

//-------------------Continually running ca update procedure

void Cellmain(HWND hwnd)
{
	HDC hdc;

	hdc = GetDC(hwnd);
	calife_list->Update_and_Show(hdc);

/* if update_flag is 1, then some procedure changed some vital information
	of the focus CA, and we need to update the information in these
	boxes */
	if (update_flag)
	{
		if (hDlgParams)
			SendMessage(hDlgParams, WM_COMMAND, SC_UPDATE, 0L);
		if (hDlgCycle)
			SendMessage(hDlgCycle, WM_COMMAND, SC_UPDATE, 0L);
		if (hDlgZap)
			SendMessage(hDlgZap, WM_COMMAND, SC_UPDATE, 0L);
		if (hDlgExp)
			SendMessage(hDlgExp, WM_COMMAND, SC_UPDATE, 0L);

		update_flag = 0;
	}

	ReleaseDC(hwnd, hdc);
}

